/*
ͻ
                                CHAPITRE V                              
͹
 Ficher: LETTRE.H                                                       
 Description: Gestion d'affichage de texte                              
 Auteur: Franck Bauquier                                                
ͼ
*/


// Pour chaque ligne le premier chiffre donne l'paisseur de la lettre
// la 2me ligne donne la 1re ligne de points de la lettre
// la 3me ligne donne la 2me ligne de points de la lettre
// etc
// 1 lettre = maximum 8 pixels de large, pour maximum 6 pixels de haut
unsigned char lettre[256][7]= {   5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  2, 0x40, 0x40, 0x40, 0x40,    0, 0x40,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  4, 0x10, 0x20, 0x40,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  4,    0,    0,    0, 0xF0,    0,    0,
				  2,    0,    0,    0,    0,    0, 0x40,
				  5,    0,    0,    0,    0,    0,    0,
				  6, 0x78, 0x84, 0x84, 0x84, 0x84, 0x78,//0
				  4, 0x20, 0x60, 0x20, 0x20, 0x20, 0x70,//1
				  4, 0x60, 0x90, 0x20, 0x40, 0x80, 0xF0,
				  4, 0xE0, 0x10, 0x60, 0x10, 0x10, 0xE0,
				  5, 0x10, 0x70, 0x90, 0xF8, 0x10, 0x10,
				  5, 0xF8, 0x80, 0x70, 0x08, 0x08, 0xF0,
				  4, 0x60, 0x90, 0x80, 0xE0, 0x90, 0x60,
				  5, 0xF8, 0x08, 0x10, 0x20, 0x40, 0x80,
				  5, 0x70, 0x88, 0x70, 0x88, 0x88, 0x70,
				  5, 0xF8, 0x88, 0xF8, 0x08, 0x88, 0xF8,
				  2,    0,    0, 0x40,    0,    0, 0x40,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5, 0x20, 0x50, 0x88, 0xF8, 0x88, 0x88,//A
				  5, 0xE0, 0x90, 0xE0, 0x90, 0x88, 0xF0,//B
				  5, 0x70, 0x88, 0x80, 0x80, 0x88, 0x70,//C
				  5, 0xF0, 0x88, 0x88, 0x88, 0x88, 0xF0,//D
				  5, 0xF8, 0x80, 0xE0, 0x80, 0x80, 0xf8,//E
				  5, 0xF8, 0x80, 0xE0, 0x80, 0x80, 0x80,//F
				  5, 0x70, 0x88, 0x80, 0xB8, 0x88, 0x70,//G
				  5, 0x88, 0x88, 0xF8, 0x88, 0x88, 0x88,//H
				  5, 0x70, 0x20, 0x20, 0x20, 0x20, 0x70,//I
				  5, 0x38, 0x10, 0x10, 0x10, 0x90, 0x60,//J
				  5, 0x90, 0xA0, 0xC0, 0xA0, 0x90, 0x88,//K
				  5, 0x80, 0x80, 0x80, 0x80, 0x88, 0xF8,//L
				  5, 0x88, 0xD8, 0xF8, 0xA8, 0x88, 0x88,//M
				  5, 0x88, 0xC8, 0xA8, 0xA8, 0x98, 0x88,//N
				  5, 0x70, 0x88, 0x88, 0x88, 0x88, 0x70,//O
				  5, 0xF0, 0x88, 0xF0, 0x80, 0x80, 0x80,//P
				  5, 0x70, 0x88, 0x88, 0x88, 0x90, 0x68,//Q
				  5, 0xF0, 0x88, 0xF0, 0x90, 0x88, 0x88,//R
				  5, 0x70, 0x80, 0x70, 0x08, 0x88, 0x70,//S
				  5, 0xF8, 0x20, 0x20, 0x20, 0x20, 0x20,//T
				  5, 0x88, 0x88, 0x88, 0x88, 0x88, 0x70,//U
				  5, 0x88, 0x88, 0x88, 0x88, 0x50, 0x20,//V
				  5, 0x88, 0x88, 0xA8, 0xA8, 0xA8, 0x70,//W
				  5, 0x88, 0x50, 0x20, 0x20, 0x50, 0x88,//X
				  5, 0x88, 0x88, 0x50, 0x20, 0x20, 0x20,//Y
				  5, 0xF8, 0x08, 0x10, 0x20, 0x40, 0xF8,//Z
				  5,    0,    0,    0,    0,    0,    0,
				  6, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04,// \
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  8,    0,    0,    0,    0,    0, 0xFF,
				  5,    0,    0,    0,    0,    0,    0,
				  4,    0,    0, 0x60, 0x30, 0x90, 0x70,//a
				  4,    0, 0x80, 0x80, 0xe0, 0x90, 0xe0,
				  3,    0,    0, 0x60, 0x80, 0x80, 0x60,
				  4, 0x10, 0x10, 0x70, 0x90, 0x90, 0x70,
				  3,    0,    0, 0x40, 0xa0, 0xc0, 0x60,//e
				  2,    0, 0x40, 0x80, 0xc0, 0x80, 0x80,
				  4,    0, 0x60, 0x90, 0xf0, 0x10, 0x60,
				  4, 0x80, 0x80, 0xe0, 0x90, 0x90, 0x90,
				  1, 0x80,    0, 0x80, 0x80, 0x80, 0x80,//i
				  4, 0x10,    0, 0x10, 0x10, 0x90, 0x60,
				  4,    0, 0x80, 0xa0, 0xc0, 0xa0, 0x90,
				  1, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80,//l
				  5,    0,    0, 0xF0, 0xa8, 0xa8, 0xa8,
				  3,    0,    0, 0xc0, 0xa0, 0xa0, 0xa0,
				  4,    0,    0, 0x60, 0x90, 0x90, 0x60,//o
				  4,    0,    0, 0xe0, 0x90, 0xe0, 0x80,
				  4,    0,    0, 0x70, 0x90, 0x70, 0x10,
				  2,    0,    0, 0xc0, 0x80, 0x80, 0x80,//r
				  3,    0,    0, 0x60, 0x80, 0x20, 0xc0,
				  2,    0, 0x80, 0xc0, 0x80, 0x80, 0x40,//t
				  4,    0,    0, 0x90, 0x90, 0x90, 0x70,
				  4,    0,    0, 0x90, 0x90, 0x90, 0x60,
				  5,    0,    0, 0xa8, 0xa8, 0xa8, 0x70,
				  4,    0,    0, 0x90, 0x60, 0x60, 0x90,
				  4,    0,    0, 0x90, 0x90, 0x20, 0x40,//y
				  4,    0,    0, 0xf0, 0x20, 0x40, 0xf0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  5,    0,    0,    0,    0,    0,    0,
				  8,    0,    0,    0,    0,    0,    0};//espace


void printX(unsigned char *message, unsigned TheX, unsigned TheY,
	    unsigned color, unsigned char*endroit);


// ͻ
//  printX - Affiche du texte  l'cran selon la police LETTRE ci-dessus  
// ͼ
void printX(unsigned char *message, unsigned TheX, unsigned TheY,
	    unsigned color, unsigned char*endroit)
{

int RC=0,LeX=TheX,LeY=TheY;
int car,Y=LeY,X=LeX;

for (int i=0;i<=strlen(message)-1;i++) // boucle de la 1re  la dernire
{                                      // lettre
car=message[i]; // car reoit le carctre  imprimer
if(car=='\n')  // Si car est un '\n'
{
RC++;          // On incrmente RC (retour chariot)
Y=TheY+(RC*8); // On saute une ligne de 8 pixels de hauteur
LeX=TheX;      // on revient au dbut de la ligne
}
else           // Sinon
{
for (int j=1;j<=6;j++) //on boucle de 1  6 (1 lettre = 6 lignes de points)
{
X=LeX;Y++; // Au fur et  mesure on saute un ligne
if (((lettre[(int)car][j])&0x80)==0x80) endroit[X+Y*320]=color;X++;
//On fait un "Et Entre Bit" pour savoir si on affiche le premier pixel
if (((lettre[(int)car][j])&0x40)==0x40) endroit[X+Y*320]=color;X++;
//On fait un "Et Entre Bit" pour savoir si on affiche le 2me pixel
if (((lettre[(int)car][j])&0x20)==0x20) endroit[X+Y*320]=color;X++;
//On fait un "Et Entre Bit" pour savoir si on affiche le 3me pixel
if (((lettre[(int)car][j])&0x10)==0x10) endroit[X+Y*320]=color;X++;
// Et ainsi de suite
if (((lettre[(int)car][j])&0x08)==0x08) endroit[X+Y*320]=color;X++;
if (((lettre[(int)car][j])&0x04)==0x04) endroit[X+Y*320]=color;X++;
if (((lettre[(int)car][j])&0x02)==0x02) endroit[X+Y*320]=color;X++;
if (((lettre[(int)car][j])&0x01)==0x01) endroit[X+Y*320]=color;
}// fin for de j
Y=TheY+(RC*8); // Se remet en position initiale avant d'attaquer une
	       // lettre sur l'axe des Y (sans oublie le saut de ligne)
LeX+=(int)lettre[(int)car][0]+1; // On se place d'une "largeur de lettre+1"
				 // plus loin sur l'axe des X
}

}// fin for de i
}// fin de la fonction



